<script setup lang="ts">
  import type {
    CustomSliderElementConfig,
    CmsElementProductSlider,
  } from '@shopware-pwa/composables-next';
  import { useCmsElementConfig } from '@shopware-pwa/composables-next';
  import { CmsActionType } from '~/logic/interfaces';
  import { CmsSlotKey, CmsPageKey } from '~/helpers/injection';

  const props = defineProps<{
    content: CmsElementProductSlider;
  }>();
  const cmsPageInject = inject(CmsPageKey);
  const cmsSlotInject = inject(CmsSlotKey);
  const sliderRef = ref();
  const { getConfigValue } = useCmsElementConfig(props.content);
  const { publishScrollTo, setContainerRef } = useElementInteraction();
  const products = computed(() => props.content?.data?.products ?? []);
  const config = computed<CustomSliderElementConfig>(() => ({
    minHeight: {
      value: '',
      source: 'static',
    },
    verticalAlign: {
      source: 'static',
      value: getConfigValue('verticalAlign') || '',
    },
    navigationDots: {
      value: '',
      source: 'static',
    },
    navigationArrows: {
      value: 'outside',
      source: 'static',
    },
    rotate: {
      value: getConfigValue('rotate') || true,
      source: 'static',
    },
  }));

  const title = computed(() => getConfigValue('title'));
  const displayMode = computed(() => getConfigValue('displayMode'));
  const boxLayout = computed(() => getConfigValue('boxLayout'));
  const border = computed(() => getConfigValue('border'));
  const sliderId = `${props.content.customFields?._uniqueIdentifier}-slider`;

  const sliderOptions = computed(() => ({
    slidesPerView: 2,
    breakpoints: {
      '768': {
        slidesPerView: 3,
        spaceBetween: 12,
      },
      '1024': {
        slidesPerView: 4,
        spaceBetween: 16,
      },
      '1920': {
        slidesPerView: 5,
        spaceBetween: 16,
      },
    },
  }));

  onMounted(() => {
    setContainerRef(sliderId, sliderRef.value?.sliderRef);
  });

  const buildProductId = (productId: string) => {
    return `${cmsSlotInject?.elementId}-${productId}`;
  };

  const handlePublish = (productId: string, index: number) => {
    publishScrollTo(props.content.customFields?._uniqueIdentifier as string, productId, [
      {
        elementId: sliderId,
        type: CmsActionType.SLIDER,
        slideIndex: index,
      },
    ]);
  };
</script>
<template>
  <div ref="productSlider" class="cms-element-product-slider">
    <h3 v-if="title" class="mb-5 text-lg font-bold text-gray-700">
      {{ title }}
    </h3>
    <div :class="{ 'border-border border p-5': border }">
      <SwSlider ref="sliderRef" :config="config" :slider-options="sliderOptions">
        <template v-if="cmsPageInject?.type === 'presentation'">
          <SwTarget
            v-for="(product, index) of products"
            :key="product.id"
            @publish="() => handlePublish(buildProductId(product.id), index)"
          >
            <CmsProductCard
              class="h-full"
              :data="product"
              :display-mode="displayMode"
              :box-layout="boxLayout"
            />
          </SwTarget>
        </template>
        <template v-else>
          <CmsProductCard
            v-for="product of products"
            :key="product.id"
            class="h-full"
            :data="product"
            :display-mode="displayMode"
            :box-layout="boxLayout"
          />
        </template>
      </SwSlider>
    </div>
  </div>
</template>
